# coding: utf-8

"""
    OurSky SDA

    The basic flow for a new organization is as follows: 1. View the available satellite targets with the [satellite targets](#tag/satellite-targets/get/v1/satellite-targets) endpoint. Copy the id of the target you want to observe. 2. Create an organization target with the [organization target](#tag/organization-targets/get/v1/organization-targets) endpoint. Use the id copied from above. 3. Create a webhook with the [webhook](#tag/webhooks/post/v1/communications/webhook) endpoint to receive TDMs automatically (preferred) or use the [tdms](#tag/tdms/get/v1/tdms) endpoint to poll for TDMs.

    The version of the OpenAPI document: 1.3.3787
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt

class V1SearchInstructionStep(BaseModel):
    """
    Search Instruction Step. Each step is associated with one observation.  # noqa: E501
    """
    along_track_offset_meters: Union[StrictFloat, StrictInt] = Field(..., alias="alongTrackOffsetMeters", description="Along-track offset in the local spacecraft frame.")
    cross_track_offset_meters: Union[StrictFloat, StrictInt] = Field(..., alias="crossTrackOffsetMeters", description="Cross-track offset in the local spacecraft frame.")
    radial_offset_meters: Union[StrictFloat, StrictInt] = Field(..., alias="radialOffsetMeters", description="Radial offset in the local spacecraft frame.")
    duration_seconds: StrictInt = Field(..., alias="durationSeconds")
    __properties = ["alongTrackOffsetMeters", "crossTrackOffsetMeters", "radialOffsetMeters", "durationSeconds"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1SearchInstructionStep:
        """Create an instance of V1SearchInstructionStep from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1SearchInstructionStep:
        """Create an instance of V1SearchInstructionStep from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1SearchInstructionStep.parse_obj(obj)

        _obj = V1SearchInstructionStep.parse_obj({
            "along_track_offset_meters": obj.get("alongTrackOffsetMeters"),
            "cross_track_offset_meters": obj.get("crossTrackOffsetMeters"),
            "radial_offset_meters": obj.get("radialOffsetMeters"),
            "duration_seconds": obj.get("durationSeconds")
        })
        return _obj


